#include <LiquidCrystal.h>
#define Offset -0.587
#define SensorPin = A3

const int rs = 6, en = 7, d4 = 5, d5 = 4, d6 = 9, d7 = 8;
LiquidCrystal lcd(rs, en, d4, d5, d6, d7);

const int button_pin_weiter = 2;
const int button_pin_enter = 3;

int button_state_weiter = 0;
int button_state_enter = 0;
int _zustand = 0;
int _unterzustand = 59;

void setup() {
  Serial.begin(9600);

  lcd.begin(16, 2);
  lcd.clear();

  pinMode(button_pin_weiter, INPUT);
  pinMode(button_pin_enter, INPUT);
}

void alter_state() {
  switch (_zustand) {
    case 0:
      if (button_state_enter == HIGH)
        _zustand = 4;
      if (button_state_weiter == HIGH)
        _zustand = 1;
      break;
    case 1:
      if (button_state_enter == HIGH)
        _zustand = 5;
      if (button_state_weiter == HIGH)
        _zustand = 2;
      break;
    case 2:
      if (button_state_enter == HIGH)
        _zustand = 6;
      if (button_state_weiter == HIGH)
        _zustand = 3;
      break;
    case 3:
      if (button_state_enter == HIGH)
        _zustand = 7;
      if (button_state_weiter == HIGH)
        _zustand = 0;
      break;
    case 4:
      if (button_state_enter == HIGH)
        _zustand = 0;
      if (button_state_weiter == HIGH)
        _zustand = 0;
      break;
    case 5:
      if (button_state_enter == HIGH)
        _zustand = 0;
      if (button_state_weiter == HIGH)
        _zustand = 0;
      break;
  }
}

void menue_phmeter() {
  lcd.setCursor(0 , 0);
  lcd.print("pH-Meter");
  lcd.setCursor(0 , 1);
  lcd.print("Enter  /  Weiter");
  delay(100);
}

void menue_kalibrieren() {
  lcd.setCursor(0 , 0);
  lcd.print("Kalibrieren");
  lcd.setCursor(0 , 1);
  lcd.print("Enter  /  Weiter");  
  delay(100);
}

void menue_haushalt() {
  lcd.setCursor(0 , 0);
  lcd.print("Haushalt");
  lcd.setCursor(0 , 1);
  lcd.print("Enter  /  Weiter");
  delay(100);
}

void menue_titration() {
  lcd.setCursor(0 , 0);
  lcd.print("Titration");
  lcd.setCursor(0 , 1);
  lcd.print("Enter  /  Weiter");
  delay(100);
}

float phvalue() {
  float a=0;
  float voltage=0;
  for (int i=0; i <= 100; i++){
    float sensorValue = analogRead(A3);

    voltage= sensorValue * (5.0 / 1024.0);

    a=a+voltage;
    //delay (2);
  }
  a=a/100;
  float pHValue= (a+Offset)/0.059;
  if (pHValue < 0){
    pHValue = 0;
  }
  if (pHValue > 14) {
    pHValue = 14;
  }
  Serial.print(a);
  Serial.print(" , ");
  Serial.println(pHValue);
  return pHValue;
}
  
float voltage() {
  float a=0;
  float voltage=0;
  for (int i=0; i <= 100; i++){
    float sensorValue = analogRead(A3);

    voltage= sensorValue * (5.0 / 1024.0);

    a=a+voltage;
    //delay (2);
  }
    
  voltage = a/100/*+Offset*/; 
  
  //Serial.print("Voltage: ");
  //Serial.println(voltage);
  return voltage;

}

void phmeter() {
  float pHValue = phvalue();

  lcd.setCursor(0, 1);
  lcd.print("pH: ");
  lcd.print(pHValue,1);
  delay(100);
}

void kalibrieren() {
  float volt = voltage();

  lcd.setCursor(0, 0);
  lcd.println("gleicheSpannung?");
  lcd.setCursor(0, 1);
  lcd.print("U=1.0V U=");
  lcd.print(volt);
  lcd.print("V");
  delay(100);
}

void haushalt() {
  if (button_state_enter == HIGH)
    _unterzustand += 1;
  if (button_state_weiter == HIGH)
    _unterzustand -= 1;
  
  switch(_unterzustand){
    case 60:
      lcd.print("Haushalts-");
      lcd.setCursor(0, 1);
      lcd.print("fluessigkeiten");
      break;
    case 61:
      lcd.print("Zitronensaft");
      break;
    case 62:
      phmeter();
      break;
    case 63:
      lcd.print("Haushaltsessig");
      break;
    case 64:
      phmeter();
      break;
    case 65:
      lcd.print("Rohrreiniger");
      break;
    case 66:
      phmeter();
      break;
    case 67:
      lcd.print("Backsoda");
      break;
    case 68:
      phmeter();
      break;  
    default:
      _zustand = 0;
      _unterzustand = 59;
  }
}

void titration() {
   if (button_state_enter == HIGH)
    _unterzustand += 1;
  if (button_state_weiter == HIGH)
    _unterzustand -= 1;
    
  switch(_unterzustand){
    case 60:
      _unterzustand = 70;
    case 70:
      lcd.print("Natralisations-");
      lcd.setCursor(0, 1);
      lcd.print("titration");
      break;
    case 71:
      lcd.print("50ml Saeure");
      lcd.setCursor(0, 1);
      lcd.print("in Becherglas?");
      break;
    case 72:
      lcd.print("Lauge in");
      lcd.setCursor(0, 1);
      lcd.print("Buerette bereit?");
      break;
    case 73:
      phmeter();
      break;
    default:
      _zustand = 0;
      _unterzustand = 59;
  }
}

void loop() {
  button_state_weiter = digitalRead(button_pin_weiter);
  button_state_enter = digitalRead(button_pin_enter);
  
  if(button_state_enter == HIGH || button_state_weiter == HIGH) {
    lcd.clear();
    Serial.print(_zustand);
    Serial.print(" , ");
    Serial.println(_unterzustand);
    delay(200);
  }
  
  lcd.setCursor(0 , 0);
  alter_state();
  
  switch (_zustand) {
    case 0:
      menue_phmeter();
      break;
    case 1:
      menue_kalibrieren();
      break;
    case 2:
      menue_haushalt();
      break;
    case 3:
      menue_titration();
      break;
    case 4:
      phmeter();
      break;
    case 5:
      kalibrieren();
      break;
    case 6:
      haushalt();
      break;
    case 7:
      titration();
      break;
  }
}
